blob: f7b7e3708a3a775bc4b3750a72e09b28fcb553fe [file] [log] [blame]
Phaneendra Manda4c62c802019-03-06 21:37:49 +05301#
2# Copyright 2016 the original author or authors.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15#
16
Matt Jeanneret8b823f62019-05-11 11:01:28 -040017# set default shell
18SHELL = bash -e -o pipefail
19
20# Variables
21VERSION ?= $(shell cat ./VERSION)
22
Matt Jeanneretf880eb62019-07-16 20:08:03 -040023DOCKER_LABEL_VCS_DIRTY = false
24ifneq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0)
25 DOCKER_LABEL_VCS_DIRTY = true
26endif
Matt Jeanneret8b823f62019-05-11 11:01:28 -040027## Docker related
Matt Jeanneretf880eb62019-07-16 20:08:03 -040028DOCKER_EXTRA_ARGS ?=
Matt Jeanneret8b823f62019-05-11 11:01:28 -040029DOCKER_REGISTRY ?=
30DOCKER_REPOSITORY ?=
Matt Jeanneret8b823f62019-05-11 11:01:28 -040031DOCKER_TAG ?= ${VERSION}
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040032ADAPTER_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-openolt-adapter:${DOCKER_TAG}
Andrea Campanellacbf583e2019-12-17 15:26:00 -080033TYPE ?= minimal
Matt Jeanneret8b823f62019-05-11 11:01:28 -040034
35## Docker labels. Only set ref and commit date if committed
Matt Jeanneretf880eb62019-07-16 20:08:03 -040036DOCKER_LABEL_VCS_URL ?= $(shell git remote get-url $(shell git remote))
37DOCKER_LABEL_VCS_REF = $(shell git rev-parse HEAD)
38DOCKER_LABEL_BUILD_DATE ?= $(shell date -u "+%Y-%m-%dT%H:%M:%SZ")
39DOCKER_LABEL_COMMIT_DATE = $(shell git show -s --format=%cd --date=iso-strict HEAD)
Matt Jeanneret8b823f62019-05-11 11:01:28 -040040
David Bainbridge788e5202019-10-21 18:49:40 +000041# Default is GO111MODULE=auto, which will refuse to use go mod if running
42# go less than 1.13.0 and this repository is checked out in GOPATH. For now,
43# force module usage. This affects commands executed from this Makefile, but
44# not the environment inside the Docker build (which does not build from
45# inside a GOPATH).
46export GO111MODULE=on
47
Matt Jeanneretf880eb62019-07-16 20:08:03 -040048DOCKER_BUILD_ARGS ?= \
49 ${DOCKER_EXTRA_ARGS} \
50 --build-arg org_label_schema_version="${VERSION}" \
51 --build-arg org_label_schema_vcs_url="${DOCKER_LABEL_VCS_URL}" \
52 --build-arg org_label_schema_vcs_ref="${DOCKER_LABEL_VCS_REF}" \
53 --build-arg org_label_schema_build_date="${DOCKER_LABEL_BUILD_DATE}" \
54 --build-arg org_opencord_vcs_commit_date="${DOCKER_LABEL_COMMIT_DATE}" \
55 --build-arg org_opencord_vcs_dirty="${DOCKER_LABEL_VCS_DIRTY}"
56
Scott Baker355d1742019-10-24 10:57:52 -070057.PHONY: docker-build local-protos local-lib-go
Phaneendra Manda4c62c802019-03-06 21:37:49 +053058
59# This should to be the first and default target in this Makefile
60help:
61 @echo "Usage: make [<target>]"
62 @echo "where available targets are:"
David Bainbridge788e5202019-10-21 18:49:40 +000063 @echo ""
64 @echo "clean : Removes any local filesystem artifacts generated by a build"
65 @echo "distclean : Removes any local filesystem artifacts generated by a build or test run"
David Bainbridge63d51812019-10-22 15:55:29 +000066 @echo "build : Build all openolt adapter artifacts"
Zack Williams95504be2019-09-03 14:17:24 -070067 @echo "docker-build : Build openolt adapter docker image"
Matt Jeanneret8b823f62019-05-11 11:01:28 -040068 @echo "docker-push : Push the docker images to an external repository"
David Bainbridge788e5202019-10-21 18:49:40 +000069 @echo "help : Print this help"
70 @echo "lint : Run all lint targets"
71 @echo "lint-mod : Verify the Go dependencies"
72 @echo "lint-sanity : Run the Go language sanity tests (vet)"
73 @echo "lint-style : Verify the Go standard format of the source"
74 @echo "local-protos : Copies a local verison of the VOLTHA protos into the vendor directory"
Scott Baker355d1742019-10-24 10:57:52 -070075 @echo "local-lib-go : Copies a local version of the VOTLHA dependencies into the vendor directory"
Girish Gowdru6a80bbd2019-07-02 07:36:09 -070076 @echo "sca : Runs various SCA through golangci-lint tool"
Matt Jeanneret8b823f62019-05-11 11:01:28 -040077 @echo "test : Run unit tests, if any"
Phaneendra Manda4c62c802019-03-06 21:37:49 +053078 @echo
79
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040080## Local Development Helpers
Phaneendra Manda4c62c802019-03-06 21:37:49 +053081
Matt Jeanneret8b823f62019-05-11 11:01:28 -040082local-protos:
William Kurkianea869482019-04-09 15:16:11 -040083ifdef LOCAL_PROTOS
Esin Karamanccb714b2019-11-29 15:02:06 +000084 rm -rf vendor/github.com/opencord/voltha-protos/v3/go
85 mkdir -p vendor/github.com/opencord/voltha-protos/v3/go
86 cp -r ${LOCAL_PROTOS}/go/* vendor/github.com/opencord/voltha-protos/v3/go
87 rm -rf vendor/github.com/opencord/voltha-protos/v3/go/vendor
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040088endif
89
Scott Baker355d1742019-10-24 10:57:52 -070090## Local Development Helpers
91local-lib-go:
92ifdef LOCAL_LIB_GO
Esin Karamanccb714b2019-11-29 15:02:06 +000093 mkdir -p vendor/github.com/opencord/voltha-lib-go/v3/pkg
94 cp -r ${LOCAL_LIB_GO}/pkg/* vendor/github.com/opencord/voltha-lib-go/v3/pkg/
William Kurkianea869482019-04-09 15:16:11 -040095endif
Matt Jeanneret8b823f62019-05-11 11:01:28 -040096
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040097## Docker targets
98
David Bainbridge63d51812019-10-22 15:55:29 +000099build: docker-build
100
Scott Baker355d1742019-10-24 10:57:52 -0700101docker-build: local-protos local-lib-go
David K. Bainbridge8eb6cd62019-08-22 13:17:29 -0700102 docker build $(DOCKER_BUILD_ARGS) -t ${ADAPTER_IMAGENAME} -f docker/Dockerfile.openolt .
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -0400103
Matt Jeanneret8b823f62019-05-11 11:01:28 -0400104docker-push:
105 docker push ${ADAPTER_IMAGENAME}
106
Andrea Campanellacbf583e2019-12-17 15:26:00 -0800107docker-kind-load:
108 @if [ "`kind get clusters | grep voltha-$(TYPE)`" = '' ]; then echo "no voltha-$(TYPE) cluster found" && exit 1; fi
109 kind load docker-image ${ADAPTER_IMAGENAME} --name=voltha-$(TYPE) --nodes $(shell kubectl get nodes --template='{{range .items}}{{.metadata.name}},{{end}}' | sed 's/,$$//')
110
111
Matt Jeanneret8b823f62019-05-11 11:01:28 -0400112## lint and unit tests
Phaneendra Manda4c62c802019-03-06 21:37:49 +0530113
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400114lint-style:
115ifeq (,$(shell which gofmt))
116 go get -u github.com/golang/go/src/cmd/gofmt
117endif
118 @echo "Running style check..."
119 @gofmt_out="$$(gofmt -l $$(find . -name '*.go' -not -path './vendor/*'))" ;\
120 if [ ! -z "$$gofmt_out" ]; then \
121 echo "$$gofmt_out" ;\
122 echo "Style check failed on one or more files ^, run 'go fmt' to fix." ;\
123 exit 1 ;\
124 fi
125 @echo "Style check OK"
126
127lint-sanity:
128 @echo "Running sanity check..."
David Bainbridge788e5202019-10-21 18:49:40 +0000129 @go vet -mod=vendor ./...
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400130 @echo "Sanity check OK"
131
David Bainbridge788e5202019-10-21 18:49:40 +0000132lint-mod:
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400133 @echo "Running dependency check..."
David Bainbridge788e5202019-10-21 18:49:40 +0000134 @go mod verify
Scott Baker22c0e9c2019-11-26 08:11:29 -0800135 @echo "Dependency check OK. Running vendor check..."
136 @git status > /dev/null
137 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && echo "`git status`" && exit 1)
138 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && echo "`git status`" && exit 1)
139 go mod tidy
140 go mod vendor
141 @git status > /dev/null
142 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1)
143 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1)
144 @echo "Vendor check OK."
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400145
David Bainbridge788e5202019-10-21 18:49:40 +0000146lint: lint-style lint-sanity lint-mod
147
148__GOPATH=$(shell go env GOPATH)
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400149
Scott Bakera4cd50d2019-10-15 16:53:38 -0700150# Rules to automatically install golangci-lint
151GOLANGCI_LINT_TOOL?=$(shell which golangci-lint)
152ifeq (,$(GOLANGCI_LINT_TOOL))
David Bainbridge788e5202019-10-21 18:49:40 +0000153GOLANGCI_LINT_TOOL=$(__GOPATH)/bin/golangci-lint
Scott Bakera4cd50d2019-10-15 16:53:38 -0700154golangci_lint_tool_install:
155 # Same version as installed by Jenkins ci-management
156 # Note that install using `go get` is not recommended as per https://github.com/golangci/golangci-lint
David Bainbridge788e5202019-10-21 18:49:40 +0000157 curl -sfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh| sh -s -- -b $(__GOPATH)/bin v1.17.0
Scott Bakera4cd50d2019-10-15 16:53:38 -0700158else
159golangci_lint_tool_install:
160endif
161
162# Rules to automatically install go-junit-report
163GO_JUNIT_REPORT?=$(shell which go-junit-report)
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400164ifeq (,$(GO_JUNIT_REPORT))
David Bainbridge788e5202019-10-21 18:49:40 +0000165GO_JUNIT_REPORT=$(__GOPATH)/bin/go-junit-report
Scott Bakera4cd50d2019-10-15 16:53:38 -0700166go_junit_install:
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400167 go get -u github.com/jstemmer/go-junit-report
Scott Bakera4cd50d2019-10-15 16:53:38 -0700168else
169go_junit_install:
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400170endif
171
Scott Bakera4cd50d2019-10-15 16:53:38 -0700172# Rules to automatically install gocover-covertura
173GOCOVER_COBERTURA?=$(shell which gocover-cobertura)
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400174ifeq (,$(GOCOVER_COBERTURA))
David Bainbridge788e5202019-10-21 18:49:40 +0000175 @GOCOVER_COBERTURA=$(__GOPATH)/bin/gocover-cobertura
Scott Bakera4cd50d2019-10-15 16:53:38 -0700176gocover_cobertura_install:
177 go get -u github.com/t-yuki/gocover-cobertura
178else
179gocover_cobertura_install:
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400180endif
181
Scott Bakera4cd50d2019-10-15 16:53:38 -0700182test: go_junit_install gocover_cobertura_install
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400183 @mkdir -p ./tests/results
184
David Bainbridge788e5202019-10-21 18:49:40 +0000185 @go test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400186 RETURN=$$? ;\
187 $(GO_JUNIT_REPORT) < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
188 $(GOCOVER_COBERTURA) < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
189 exit $$RETURN
190
Girish Gowdru6a80bbd2019-07-02 07:36:09 -0700191GOLANGCI_LINT_TOOL:=$(shell which golangci-lint)
Scott Bakera4cd50d2019-10-15 16:53:38 -0700192sca: golangci_lint_tool_install
Girish Gowdru6a80bbd2019-07-02 07:36:09 -0700193 @mkdir -p ./sca-report
David Bainbridge788e5202019-10-21 18:49:40 +0000194 golangci-lint run --out-format junit-xml ./... 2>&1 | tee ./sca-report/sca-report.xml
Girish Gowdru6a80bbd2019-07-02 07:36:09 -0700195
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -0400196clean:
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -0400197
198distclean: clean
Scott Bakera4cd50d2019-10-15 16:53:38 -0700199 rm -rf ./sca_report
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -0400200
Phaneendra Manda4c62c802019-03-06 21:37:49 +0530201# end file